'+--------------------------------------------------------------------------+
'|                                 MTC32                                    |
'|                                                                          |
'|                     GDImage muedia tuning controls                       |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2014                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 06-29-2014 (MM-DD-YYYY)            |
'|                        Last revised : 07-05-2014 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "MTC32.exe"

%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%IDC_ARROW                                      = 32512&
%COLOR_WINDOW                                   = 5

%ERROR_ALREADY_EXISTS                           = 183&
%SW_RESTORE                                     = 9
%WM_DESTROY                                     = &H2
%WM_SIZE                                        = &H5
%WM_PAINT                                       = &HF
%WM_MOUSEMOVE                                   = &H200
%WM_TIMER                                       = &H113
%WM_CLOSE                                       = &H10
%WM_COMMAND                                     = &H111
%WM_LBUTTONDOWN                                 = &H201
%WM_RBUTTONDOWN                                 = &H204
%WM_GETMINMAXINFO                               = &H24
%WM_ERASEBKGND                                  = &H14
%WM_HSCROLL                                     = &H114
%WM_VSCROLL                                     = &H115
%WM_NOTIFY                                      = &H4E

%SB_THUMBPOSITION                               = 4

%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_CAPTION                                     = &H00C00000  '// WS_BORDER or WS_DLGFRAME
%WS_SYSMENU                                     = &H00080000
%WS_THICKFRAME                                  = &H00040000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000

%CS_VREDRAW                                     = &H1
%CS_HREDRAW                                     = &H2

%PM_REMOVE                                      = &H0001
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1
%MAX_PATH                                       = 260

type NMHDR
    hwndFrom as DWORD
    idfrom as DWORD
    code as long '// used for messages, so needs to be LONG, not DWORD...
end type

type RECT
    nLeft as long
    nTop as long
    nRight as long
    nBottom as long
end type

type POINTAPI
    x as long
    y as long
end type

type tagMSG
    hwnd as DWORD
    message as DWORD
    wParam as long
    lParam as long
    time as DWORD
    pt as POINTAPI
end type

type SECURITY_ATTRIBUTES
    nLength as DWORD
    lpSecurityDescriptor as long
    bInheritHandle as long
end type

type WNDCLASSEX
    cbSize as DWORD
    style as DWORD
    lpfnWndProc as long
    cbClsExtra as long
    cbWndExtra as long
    hInstance as DWORD
    hIcon as DWORD
    hCursor as DWORD
    hbrBackground as DWORD
    lpszMenuName as ASCIIZ PTR
    lpszClassName as ASCIIZ PTR
    hIconSm as DWORD
end type

type MINMAXINFO
    ptReserved as POINTAPI
    ptMaxSize as POINTAPI
    ptMaxPosition as POINTAPI
    ptMinTrackSize as POINTAPI
    ptMaxTrackSize as POINTAPI
end type

TYPE FILETIME
    dwLowDateTime as DWORD
    dwHighDateTime as DWORD
END TYPE

TYPE WIN32_FIND_DATA
    dwFileAttributes as DWORD
    ftCreationTime as FILETIME
    ftLastAccessTime as FILETIME
    ftLastWriteTime as FILETIME
    nFileSizeHigh as DWORD
    nFileSizeLow as DWORD
    dwReserved0 as DWORD
    dwReserved1 as DWORD
    cFileName as ASCIIZ * %MAX_PATH
    cAlternateFileName as ASCIIZ * 14
END TYPE

%LB_ADDSTRING                                   = &H180
%LB_INSERTSTRING                                = &H181
%LB_FINDSTRING                                  = &H18F
%LB_GETTEXT                                     = &H189
%LB_GETTEXTLEN                                  = &H18A
%LB_DELETESTRING                                = &H182
%LB_RESETCONTENT                                = &H184
%LB_SETCURSEL                                   = &H186
%LB_GETCURSEL                                   = &H188
%LB_GETCOUNT                                    = &H18B
%LBS_SORT                                       = &H2&

%SND_FILENAME                                   = &H00020000???
%SND_ASYNC                                      = &H0001???

declare sub      PostQuitMessage lib "USER32.DLL" alias "PostQuitMessage" (byval nExitCode as long)
declare function FindFirstFile lib "KERNEL32.DLL" alias "FindFirstFileA" (lpFileName as ASCIIZ, lpFindFileData as WIN32_FIND_DATA) as long
declare function FindClose lib "KERNEL32.DLL" alias "FindClose" (byval hFindFile as DWORD) as long
declare function FindNextFile lib "KERNEL32.DLL" alias "FindNextFileA" (byval hFindFile as DWORD, lpFindFileData as WIN32_FIND_DATA) as long
declare function CharLowerA lib "USER32.DLL" alias "CharLowerA" (lpsz as ASCIIZ) as DWORD
declare function SendMessageA lib "USER32.DLL" alias "SendMessageA" (byval hWnd as DWORD, byval dwMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
declare function PlaySound lib "WINMM.DLL" ALIAS "PlaySoundA" (pszSound as ASCIIZ, byval hmod as DWORD, byval fdwSound as DWORD) as long
declare function GetParent LIB "USER32.DLL" alias "GetParent" (byval hWnd as DWORD) as DWORD
declare function PostMessage lib "USER32.DLL" alias "PostMessageA" (byval hWnd as DWORD, byval dwMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
declare function CopyFile lib "KERNEL32.DLL" alias "CopyFileA" (lpExistingFileName as ASCIIZ, lpNewFileName as ASCIIZ, byval bFailIfExists as long) as long
declare function AdjustWindowRectEx lib "USER32.DLL" alias "AdjustWindowRectEx" (lpRect as RECT, byval dsStyle as long, byval bMenu as long, byval dwEsStyle as DWORD) as long
declare function CloseHandle lib "KERNEL32.DLL" alias "CloseHandle" (byval hObject as DWORD) as long
declare function CreateMutex lib "KERNEL32.DLL" alias "CreateMutexA" (lpMutexAttributes as SECURITY_ATTRIBUTES, byval bInitialOwner as long, lpName as ASCIIZ) as long
declare function DefWindowProc lib "USER32.DLL" alias "DefWindowProcA" (byval hWnd as DWORD, byval uMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
declare function DispatchMessage lib "USER32.DLL" alias "DispatchMessageA" (lpMsg as tagMSG) as long
declare function FindWindow lib "USER32.DLL" alias "FindWindowA" (lpClassName as ASCIIZ, lpWindowName as ASCIIZ) as long
declare function GetClassInfoEx lib "USER32.DLL" alias "GetClassInfoExA" (byval hInst as DWORD, lpszClass as ASCIIZ, lpWndClass as WNDCLASSEX) as long
declare function GetClientRect lib "USER32.DLL" alias "GetClientRect" (byval hwnd as DWORD, lpRect as RECT) as long
declare function GetLastError lib "KERNEL32.DLL" alias "GetLastError" () as long
declare function GetMessage lib "USER32.DLL" alias "GetMessageA" (lpMsg as tagMSG, byval hWnd as DWORD, byval uMsgFilterMin as DWORD, byval uMsgFilterMax as DWORD) as long
declare function GetSystemMetrics lib "USER32.DLL" alias "GetSystemMetrics" (byval nIndex as long) as long
declare function IsIconic lib "USER32.DLL" alias "IsIconic" (byval hWnd as DWORD) as long
declare function LoadCursor lib "USER32.DLL" alias "LoadCursorA" (byval hInstance as DWORD, lpCursorName as ASCIIZ) as DWORD
declare function LoadIcon lib "USER32.DLL" alias "LoadIconA" (byval hInstance as DWORD, lpIconName as ASCIIZ) as DWORD
declare function PeekMessage lib "USER32.DLL" alias "PeekMessageA" (lpMsg as tagMSG, byval hWnd as DWORD, byval dwMsgFilterMin as DWORD, byval dwMsgFilterMax as DWORD, byval dwRemoveMsg as DWORD) as long
declare function RegisterClassEx lib "USER32.DLL" alias "RegisterClassExA" (pcWndClassEx as WNDCLASSEX) as WORD
declare function SetFocus lib "USER32.DLL" alias "SetFocus" (byval hWnd as DWORD) as long
declare function SetForegroundWindow lib "USER32.DLL" alias "SetForegroundWindow" (byval hWnd as DWORD) as long
declare function SetRect lib "USER32.DLL" alias "SetRect" (lpRect as RECT, byval X1 as long, byval Y1 as long, byval X2 as long, byval Y2 as long) as long
declare function ShowWindow lib "USER32.DLL" alias "ShowWindow" (byval hWnd as DWORD, byval nCmdShow as long) as long
declare function TranslateMessage lib "USER32.DLL" alias "TranslateMessage" (lpMsg as tagMSG) as long
declare function GetModuleFileName lib "KERNEL32.DLL" alias "GetModuleFileNameA" (byval hModule as DWORD, byref lpFilename as ASCIIZ, byval nSize as DWORD) as DWORD
declare function PathCombine lib "SHLWAPI.DLL" alias "PathCombineA" (byref lpszDest as ASCIIZ, byref lpszDir as ASCIIZ, byref lpszFile as ASCIIZ) as long
declare function zTrace lib "zTrace.DLL" alias "zTrace" (zMessage as ASCIIZ) as long
declare function KillTimer lib "USER32.DLL" alias "KillTimer" (byval hWnd as DWORD, byval nIDEvent as long) as long
declare function SetTimer lib "USER32.DLL" alias "SetTimer" (byval hWnd as DWORD, byval nIDEvent as long, byval uElapse as DWORD, byval lpTimerFunc as long) as long
declare function CreateWindowExA lib "USER32.DLL" alias "CreateWindowExA" (byval dwStyleEx as DWORD, lpClassName as ASCIIZ, lpWindowName as ASCIIZ, byval dwStyle as DWORD, byval x as long, byval y as long, _
                                                                           byval nWidth as long, byval nHeight as long, byval hWndParent as DWORD, byval hMenu as DWORD, byval hInstance as DWORD, lpParam as ANY) as DWORD

#INCLUDE "gdimage.inc"
#INCLUDE "winlift.inc"

type PROP
    hMain      as DWORD
    hList      as DWORD
    imagectrl  as DWORD
    hInstance  as DWORD
    focusID    as long
    seedangle  as long
    prevangle  as long
    wasangle   as long
    szresource as ASCIIZ * %MAX_PATH
end type

GLOBAL gP as PROP

MACRO CONST = MACRO

%ON               = 1
%OFF              = 2
%UP               = 1
%DOWN             = 2

%IDC_CTRL         = -1
%IDC_TIMER        = -2
%ClientWidth      = 782
%ClientHeight     = 440

'// Each sprite object must have a UNIQUE IDENTIFIER
%ID_BACKGROUND    = 1
%ID_CAPTION       = 2
%ID_GRID          = 3
%ID_POWER         = 4
%ID_PULSE         = 5
%ID_LIST_FRAME    = 6
%ID_LIST_TEXT     = 7
%ID_LIST_GLASS    = 8

%ID_WIDGET        = 1000

%ID_GAUGE_SWITCH  = 100 + %ID_WIDGET
%ID_GAUGE_BACK    = 200 + %ID_WIDGET
%ID_GAUGE_FRONT   = 210 + %ID_WIDGET
%ID_GAUGE_LIGHT   = 220 + %ID_WIDGET

%ID_TICK_BACK     = 300 + %ID_WIDGET
%ID_TICK_FRONT    = 310 + %ID_WIDGET
%ID_TICK_TEXT     = 320 + %ID_WIDGET

%ID_SLIDER_VERT   = 400 + %ID_WIDGET
%ID_THUMB_VERT    = 410 + %ID_WIDGET

sub ListDeleteAll(byval hList as DWORD)
    if hList then SendMessageA(hList, %LB_RESETCONTENT, 0, 0)
end sub

sub ListSelectPlus(byval hList as DWORD, byval nSelected as long)
    if nSelected > 0 then decr nSelected '// Because ListBox is zero based
    if hList then SendMessageA(hList, %LB_SETCURSEL, nSelected, 0)
end sub

function ListFindString(byval hList as DWORD, zTmp as ASCIIZ) as long
    local nIndex as long
    nIndex = SendMessageA(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    if nIndex > -1 then incr nIndex: function = nIndex
end function

function ListCount(byval hList as DWORD) as long
    if hList then function = SendMessageA(hList, %LB_GETCOUNT, 0, 0)
end function

function ListGetCursel(byval hList as DWORD) as long
    local nSelected as long
    if hList then
       nSelected = SendMessageA(hList, %LB_GETCURSEL, 0, 0)
       if nSelected > -1 then incr nSelected '// Because ListBox is zero based
    end if
    function = nSelected
end function

function ListAdd(byval hList as DWORD, zTmp as ASCIIZ) as long
    if hList then
       if len(zTmp) then function = SendMessageA(hList, %LB_INSERTSTRING, -1, VARPTR(zTmp))
    end if
end function

function ListGetText(byval hList as DWORD, byval nItem as long) as string
    local sItem as string, nLen as long
    if nItem > 0 then
       decr nItem
       nLen = SendMessageA(hList, %LB_GETTEXTLEN, nItem, 0)
       sItem = SPACE$(nLen)
       SendMessageA(hList, %LB_GETTEXT, nItem, byval STRPTR(sItem))
       function = sItem
    end if
end function

sub ListDelete(byval hList as DWORD, byval nIndex as long)
    if nIndex > 0 THEN decr nIndex '// Because ListBox is zero based
    if hList then SendMessageA(hList, %LB_DELETESTRING, nIndex, 0)
end sub

sub ListInsert(byval hList as DWORD, byval nIndex as long, zTmp as ASCIIZ)
    if nIndex > 0 THEN decr nIndex '// Because ListBox is zero based
    SendMessageA(hList, %LB_INSERTSTRING, nIndex, VARPTR(zTmp))
end sub

function sMsg(byval UpDown as long) as string
    local sItem as string, nCount as long
    if UpDown = %DOWN then
        sItem = ListGetText(gP.hList, 1)
        ListDelete(gP.hList, 1)
        ListAdd(gP.hList, (sItem))
    elseif UpDown = %UP then
        sItem = ListGetText(gP.hList, ListCount(gP.hList))
        ListDelete(gP.hList, ListCount(gP.hList))
        ListInsert(gP.hList, 1, (sItem))
    end if
    sItem = ListGetText(gP.hList, 1) + $crlf + _
    ListGetText(gP.hList, 2) + $crlf + _
    ListGetText(gP.hList, 3) + $crlf + _
    ListGetText(gP.hList, 4) + $crlf + _
    ListGetText(gP.hList, 5)
    function = sItem
end function

function EXEpath() as string
    static szExepath as asciiz * %MAX_PATH
    if GetModuleFileName(0, szExepath, %MAX_PATH) then
        local K, nLen, nPos as long
        nLen = len(szExepath)
        nPos = nLen
        for K = 1 to nLen
            if ASC(szExepath, nPos - K) <> 92 then
                MID$(szExepath, nPos - K, 1) = CHR$(0)
            else
                exit for
            end if
        next
    end if
    function = szExepath
end function

function EXEresource() as string
    static szResource as asciiz * %MAX_PATH
    PathCombine(szResource, EXEpath(), "Resource\")
    function = szResource
end function

sub ListBoxFill(byval sFilter as string, byval sSearch as string, byval sBackground as string)
    local K, nCount, nBackground as long
    gP.hList = CreateWindowExA(0, "LISTBOX", "", %WS_CHILD or %LBS_SORT, 0, 0, 0, 0, gP.hMain, 0, gP.hInstance, byval %NULL)
    ListDeleteAll(gP.hList)
    local zTmp as asciiz * %MAX_PATH
    local WashFind, hFind as DWORD
    'local sItem as string
    local fd as WIN32_FIND_DATA
    WashFind = FindFirstFile((sSearch), fd)
    hFind = WashFind
    do while hFind > 0
       if asc(fd.cFileName) <> 46 then
          if instr(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) then
             zTmp = fd.cFileName: CharLowerA(zTmp)
             IF INSTR(sFilter, right$(zTmp, 4) + ".") then
                 if ListAdd(gP.hList, zTmp) > -1 then
                     nCount += 1
                     if (zTmp = sBackground) then nBackground = nCount
                 end if
             end if
          end if
       end if
       hFind = FindNextFile(WashFind, fd)
    loop
    FindClose(WashFind)
    if nCount < 5 then
        zTmp = " "
        if nCount < 4 then
           for K = 1 to 2: ListInsert(gP.hList, 1, zTmp): nCount +=1: next
        else
           ListInsert(gP.hList, 1, zTmp): nCount += 1
           'sItem = ListGetText(gP.hList, ListCount(gP.hList))
           ListDelete(gP.hList, ListCount(gP.hList))
           ListInsert(gP.hList, 1, zTmp)
        end if
        if nCount < 5 then
           nCount += 1
           for K = nCount to 5: ListAdd(gP.hList, zTmp): next
        end if
    end if
    if (nBackground > 0) then
        if (ListGetText(gP.hList, 3) <> sBackground) then
            local sItem as string
            do 
                sItem = ListGetText(gP.hList, 1)
                ListDelete(gP.hList, 1)
                ListAdd(gP.hList, (sItem))
            loop while (ListGetText(gP.hList, 3) <> sBackground)
        end if
    end if
end sub

function IsPowerOn () as long
    local nRet as long
    nRet = 0: if ZD_GetObjectFrameToUse(%ID_POWER) = %ON then nRet = -1
    function = nRet
end function

sub MoveThumbVert(byval nID as long, byval nMouseY as long, byval THUMB_VERT as long, byval SLIDER_VERT as long)
    local x, y, nY, w, h, nH, nHalf, nPosY, nPercent as long
    if (nID < THUMB_VERT) then nID += THUMB_VERT - SLIDER_VERT
    ZD_GetObjectXY(nID - (THUMB_VERT - SLIDER_VERT), x, nY)
    ZD_GetObjectBound(nID - (THUMB_VERT - SLIDER_VERT), w, nH)
    ZD_GetObjectBound(nID, w, h)
    ZD_GetObjectXY(nID, x, y)
    nHalf = h \ 2
    y = min&(max&(nMouseY - nHalf, nY + 3 - nHalf), nY + nH - 2 - nHalf)
    ZD_SetObjectXY(nID, x, y, %TRUE)

    nPosY = (nY + nH - 2) - (y + nHalf)
    nPercent = (nPosY / (nH - 5)) * 100
    PostMessage(GetParent(gP.imagectrl), %WM_VSCROLL, MAKLNG(%SB_THUMBPOSITION, nPercent), nID)
end sub

sub ResetThumbVert(byval nID as long, byval THUMB_VERT as long, byval SLIDER_VERT as long)
    local x, y, nY, w, h, nH, nHalf, nPosY, nPercent as long
    if (nID < THUMB_VERT) then nID += THUMB_VERT - SLIDER_VERT
    ZD_GetObjectXY(nID - (THUMB_VERT - SLIDER_VERT), x, nY)
    ZD_GetObjectBound(nID - (THUMB_VERT - SLIDER_VERT), w, nH)
    ZD_GetObjectBound(nID, w, h)
    ZD_GetObjectXY(nID, x, y)

    nHalf = nY + (nH / 2) - ((h / 2) - 1)
    if (nHalf <> y) then 
        y = nHalf
        ZD_SetObjectXY(nID, x, y, %TRUE)

        nHalf = h \ 2
        nPosY = (nY + nH - 2) - (y + nHalf)
        nPercent = (nPosY / (nH - 5)) * 100
        PostMessage(GetParent(gP.imagectrl), %WM_VSCROLL, MAKLNG(%SB_THUMBPOSITION, nPercent), nID)
    end if
end sub

sub SetThumbVert(byval nID as long, byval nPercent as long, byval THUMB_VERT as long, byval SLIDER_VERT as long, byval nRedrawFlag as long)
    local x, y, nY, w, h, nH, nHalf, nPosY as long
    if (nID < THUMB_VERT) then nID += THUMB_VERT - SLIDER_VERT
    ZD_GetObjectXY(nID - (THUMB_VERT - SLIDER_VERT), x, nY)
    ZD_GetObjectBound(nID - (THUMB_VERT - SLIDER_VERT), w, nH)
    ZD_GetObjectBound(nID, w, h)
    ZD_GetObjectXY(nID, x, y)
    nHalf = h \ 2

    y = (nY + nH - 2) - ((nPercent * (nH - 5)) / 100) - nHalf
    ZD_SetObjectXY(nID, x, y, nRedrawFlag)
end sub

function IsGAUGE (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_GAUGE_BACK - 1) and (nID < %ID_GAUGE_LIGHT + (%ID_GAUGE_FRONT - %ID_GAUGE_BACK))) then nRet = -1
    function = nRet
end function

function IsSLIDER (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_SLIDER_VERT - 1) and (nID < %ID_THUMB_VERT + (%ID_THUMB_VERT - %ID_SLIDER_VERT))) then nRet = -1
    function = nRet
end function

function IsTICKER (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_TICK_BACK - 1) and (nID < %ID_TICK_FRONT + (%ID_TICK_FRONT - %ID_TICK_BACK))) then nRet = -1
    function = nRet
end function

function IsSWITCH (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_GAUGE_SWITCH - 1) and (nID < %ID_GAUGE_BACK)) then nRet = -1
    function = nRet
end function

sub SetTICKER(byval nID as long, byval nMouseX as long, byval nMouseY as long, byval seedangle as long)
    local x, y, w, h, nAngle, nTick as long
    static nmh AS NMHDR

    if (nID < %ID_TICK_FRONT) then nID += %ID_TICK_FRONT - %ID_TICK_BACK
    ZD_GetObjectXY(nID, x, y)
    ZD_GetObjectBound(nID, w, h)
    
    if (seedangle < 0) then
        if (nMouseY > y + (h \ 2)) then
            if (nMouseX > x + (h \ 2)) then
                nMouseX = x + (x + h - nMouseX)
                nMouseY = y + (y + h - nMouseY)
            else
                nMouseX = x + h -(nMouseX - x)
                nMouseY = y + h -(nMouseY - y)
            end if
        end if
    end if

    nAngle = ZD_ComputeObjectAngleFromPoint(nID, nMouseX, nMouseY) - 270
    ZD_SetObjectAngle(nID, 0, %FALSE)
    if (nAngle < 0) then nAngle += 360
    if (nAngle > 359) then nAngle -= 360
    if (nMouseX < x + (h \ 2)) then
        nTick = (nAngle + 15) \ 30
        if (nAngle + 15 > 359) then nTick = 0
        nAngle = nTick * 30
        if ((nAngle < 270) and (nTick <> 0)) then nAngle = 270
        if (nTick) then nTick -= 12
    else
        nTick = (nAngle + 15) \ 30
        nAngle = nTick * 30
        if (nAngle > 90) then nAngle = 90
    end if
    ZD_SetObjectAngle(nID, nAngle, %TRUE)
    
    '// Notify the parent of the tick value
    nmh.code = min&(max&(nTick, -3), 3)
    nmh.idFrom = nID
    nmh.hwndFrom = gP.imagectrl
    PostMessage(GetParent(gP.imagectrl), %WM_NOTIFY, nID, BYVAL VARPTR(nmh))
end sub

function GDImageCallBack(byval hWnd as long, byval Msg as long, byval wParam as long, byval lParam as long) EXPORT as long
    local x, y, w, h, nID, nFrame, nRet, useAngle, nAngle, nMouseX, nMouseY, nTick as long
    static nmh AS NMHDR
    local hBitmap as DWORD
    nRet = %FALSE '// do not stop the event processing in GDImage
    nID = ZI_MouseOverObjectID()

    select case long Msg

    case %WM_LBUTTONDOWN, %WM_LBUTTONDBLCLK
         nMouseX = LO(INTEGER, lParam): nMouseY = HI(INTEGER, lParam)
         gP.focusID = 0
         if (IsSLIDER(nID)) then
             if (IsPowerOn()) then
                 MoveThumbVert(nID, HI(INTEGER, lParam), %ID_THUMB_VERT, %ID_SLIDER_VERT)
             end if
         elseif (IsGAUGE(nID)) then
             if (ZD_GetObjectFrameToUse(nID - (%ID_GAUGE_FRONT - %ID_GAUGE_SWITCH)) = %ON) THEN '// %ID_GAUGE_SWITCH Must be ON
                 gP.seedangle = ZD_ComputeObjectAngleFromPoint(nID, nMouseX, nMouseY)
                 gP.focusID = nID
             end if
         elseif (IsTICKER(nID)) then
             gP.seedangle = 0
             gP.focusID = nID
         end if

    case %WM_RBUTTONDOWN, %WM_RBUTTONDBLCLK
         if (IsSLIDER(nID)) then
             if (IsPowerOn()) then ResetThumbVert(nID, %ID_THUMB_VERT, %ID_SLIDER_VERT)
         end if

    case %WM_LBUTTONUP
         nMouseX = LO(INTEGER, lParam): nMouseY = HI(INTEGER, lParam)
         if (nID < %ID_WIDGET) then
             if nID = %ID_POWER then
                 nFrame = ZD_GetObjectFrameToUse(nID) + 1: if nFrame > ZD_GetObjectFrameCount(nID) then nFrame = 1
                 ZD_SetObjectFrameToUse(%ID_GRID, nFrame, %FALSE)

                 for nID = %ID_GAUGE_SWITCH to %ID_GAUGE_SWITCH + 9
                     ZD_SetObjectFrameToUse(nID, nFrame, %FALSE)
                 next

                 ZD_SetObjectFrameToUse(%ID_POWER, nFrame, %TRUE)
             elseif nID = %ID_LIST_GLASS then
                 if (IsPowerOn()) then
                     ZD_GetObjectXY(%ID_LIST_GLASS, x, y)
                     ZD_GetObjectBound(%ID_LIST_GLASS, w, h)
                     if (HI(INTEGER, lParam) - y) > h \ 2 then nID = %DOWN else nID = %UP
                     ZD_SetObjectTextEx(%ID_LIST_TEXT, (sMsg(nID)), %TRUE)

                     '// We change the background
                     PathCombine(gP.szresource, EXEresource(), ListGetText(gP.hList, 3))
                     hBitmap = ZI_FitBitmapFromFile(gP.szresource, %ClientWidth, %ClientHeight)
                     if (hBitmap) then
                         ZD_DrawBitmapToCtrl(gP.imagectrl, 0, 0, hBitmap, ZD_ColorARGB(255, 0), %ID_BACKGROUND, %ZS_VISIBLE)
                         ZI_UpdateWindow(gP.imagectrl, 0)
                         CopyFile(gP.szresource, EXEresource() + "back" + PATHNAME$(EXTN, ListGetText(gP.hList, 3)), %FALSE)
                     end if
                 end if
             end if
         elseif (IsSWITCH(nID)) then
             if (IsPowerON()) then
                 nFrame = ZD_GetObjectFrameToUse(nID) + 1: if nFrame > ZD_GetObjectFrameCount(nID) then nFrame = 1
                 ZD_SetObjectFrameToUse(nID, nFrame, %TRUE)
             end if
         elseif (IsTICKER(nID)) then
             if (gP.seedangle > -1) then
                 SetTICKER(nID, nMouseX, nMouseY, gP.seedangle)
             end if
             gP.seedangle = 0
         elseif (gP.focusID) then
             if (gP.focusID > %ID_GAUGE_FRONT - 1) then
                 gP.prevangle = ZD_GetObjectAngle(gP.focusID)
                 gP.focusID = 0
             end if
         end if

    case %WM_MOUSEMOVE
         nMouseX = LO(INTEGER, lParam): nMouseY = HI(INTEGER, lParam)
         if (ZI_IsLButtonDown()) then
             if (gP.focusID) then
                 if (IsGAUGE(gP.focusID)) then
                     useAngle = ZD_ComputeObjectAngleFromPoint(gP.focusID, nMouseX, nMouseY)
                     if (useAngle <> gP.wasangle) THEN
                         nAngle = gP.prevangle + useAngle - gP.seedangle
                         if (nAngle < 0) then nAngle += 360
                         if (nAngle > 359) then nAngle -= 360
                         if (ZD_GetObjectFrameCount(gP.focusID) > 2) then '// In case of light frame
                             ZD_SetObjectAngle(gP.focusID + (%ID_GAUGE_FRONT - %ID_GAUGE_BACK), nAngle, %FALSE)
                         end if
                         ZD_SetObjectAngle(gP.focusID, nAngle, %TRUE)

                         '// Notify the parent of the new angle value
                         nmh.code = nAngle
                         nmh.idFrom = gP.focusID
                         nmh.hwndFrom = gP.imagectrl
                         PostMessage(GetParent(gP.imagectrl), %WM_NOTIFY, gP.focusID, BYVAL VARPTR(nmh))
                     end if
                     gP.wasangle = useAngle
                 elseif (IsTICKER(gP.focusID)) then
                     gP.seedangle = -1
                     SetTICKER(gP.focusID, nMouseX, nMouseY, gP.seedangle)                     
                 end if
             elseif nID = %ID_LIST_GLASS then
                 if IsPowerOn() then
                     ZD_GetObjectXY(%ID_LIST_GLASS, x, y)
                     ZD_GetObjectBound(%ID_LIST_GLASS, w, h)
                     if (HI(INTEGER, lParam) - y) > h \ 2 then nID = %DOWN else nID = %UP
                     ZD_SetObjectTextEx(%ID_LIST_TEXT, (sMsg(nID)), %TRUE)
                 end if
             elseif (IsSLIDER(nID)) then
                 if (IsPowerOn()) then
                     MoveThumbVert(nID, HIINT(lParam), %ID_THUMB_VERT, %ID_SLIDER_VERT)
                 end if
             end if

         end if

    end select

    function = nRet
end function

sub CreateGauge(byval hBitmap as DWORD, byval GAUGE_BACK as long, byval GAUGE_FRONT as long, byval GAUGE_LIGHT as long, byval x as long, byval y as long, byval nCount as long, byval xStep as long)
    local bmW, bmH, nID, nBack, nFront, nLight, nFrameCount as long
    if (hBitmap) then
        ZI_GetBitmapSize(hBitmap, bmW, bmH)
        nFrameCount = (bmW \ bmH)
        nID = GAUGE_BACK
        for nID = GAUGE_BACK to GAUGE_BACK + nCount - 1
            nBack = nID: nFront = nID + (GAUGE_FRONT - GAUGE_BACK): nLight = nID + (GAUGE_LIGHT - GAUGE_BACK)
            if (nID = GAUGE_BACK) then '// Use clone to save memory
                ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, ZD_ColorARGB(255, 0), nBack, %ZS_VISIBLE)
            else
                ZD_CloneObject(GAUGE_BACK, nBack, x, y)
            end if
            ZD_SetObjectLinked(nBack, nBack)
            ZD_SetObjectFrameCount(nBack, nFrameCount)
            ZD_SetObjectFrameToUse(nBack, 1, %FALSE)
            ZD_SetObjectAnchorMode(nBack, %ANCHOR_CENTER)
            ZD_SetObjectLocked(nBack, %TRUE)
            '// The static GAUGEFRONT sprite.
            ZD_CloneObject(nBack, nFront, x, y)
            ZD_SetObjectLinked(nFront, nBack)
            ZD_SetObjectFrameToUse(nFront, 2, %FALSE)
            ZD_SetObjectLocked(nFront, %TRUE) '// We lock the GAUGEFRONT, because we want to rotate it with the mouse
            if (nFrameCount > 2) then
                ZD_CloneObject(nBack, nLight, x, y)
                ZD_SetObjectLinked(nLight, nBack)
                ZD_SetObjectFrameToUse(nLight, 3, %FALSE)
                ZD_SetObjectZorder (nLight, ZD_GetObjectZorder(nBack))
                ZD_SetObjectLocked(nLight, %TRUE)
            end if
            x += xStep + bmH
        next
    end if
end sub

sub CreateSwitch(byval hBitmap as DWORD, byval OFF_ON as long, byval x as long, byval y as long, byval nCount as long, byval xStep as long)
    local bmW, bmH, nID as long
    if (hBitmap) then
        ZI_GetBitmapSize(hBitmap, bmW, bmH)
        nID = OFF_ON
        for nID = OFF_ON to OFF_ON + nCount - 1
            if (nID = OFF_ON) then
                ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
            else
                ZD_CloneObject(OFF_ON, nID, x, y)
            end if
            ZD_SetObjectFrameCount(nID, 2)
            ZD_SetObjectFrameToUse(nID, 2, %FALSE)
            ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
            ZD_SetObjectLocked(nID, %TRUE)
            x += xStep + bmH
        next
    end if
end sub

sub CreateVerticalSlider(byval hBitmap as DWORD, byval hThumb as DWORD, byval nX as long, byval nY as long, byval xWidth as long, byval xStep as long, byval nCount as long)
    local x, y, bmW, bmH, nID as long
    nCount -= 1
    if (hBitmap) then
        ZI_GetBitmapSize(hBitmap, bmW, bmH)
        x = nX + ((xWidth - bmW) \ 2)
        y = nY
        for nID = %ID_SLIDER_VERT to %ID_SLIDER_VERT + nCount
            if (nID = %ID_SLIDER_VERT) then
                ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
            else
                ZD_CloneObject(%ID_SLIDER_VERT, nID, x, y)
            end if
            ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
            ZD_SetObjectLocked(nID, %TRUE)
            x += xWidth + xStep
        next
        y = nY + (bmH \ 2)
        if (hThumb) then
            ZI_GetBitmapSize(hThumb, bmW, bmH)
            x = nX + ((xWidth - bmW) \ 2)
            y -= bmH \ 2 - 1
            for nID = %ID_THUMB_VERT to %ID_THUMB_VERT + nCount
                if (nID = %ID_THUMB_VERT) then
                    ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hThumb, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
                else
                    ZD_CloneObject(%ID_THUMB_VERT, nID, x, y)
                end if
                ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
                ZD_SetObjectLocked(nID, %TRUE)
                x += xWidth + xStep
            next
        end if
    end if
end sub

sub CreateControls()
    local x, y, w, h, nLeftX, nRightX, bmW, bmH, nID, nBack, nFront, nLight, xWidth, xStep, nEnum as long
    xWidth = 64: xStep = 4
    local nFrameCount as byte
    local hBitmap, hThumb as DWORD
    local sBackground as string: sBackground = LCASE$("back.jpg")

    '// Populate our custom graphic ListBox
    ListBoxFill(".gif.bmp.png.jpg.", EXEresource() + "back*.*", sBackground)

    PathCombine(gP.szresource, EXEresource(), (sBackground))
    hBitmap = ZI_FitBitmapFromFile(gP.szresource, %ClientWidth, %ClientHeight)
    if (hBitmap) then
        nID = %ID_BACKGROUND
        ZD_DrawBitmapToCtrl(gP.imagectrl, 0, 0, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if

    '// Create multiple gauges
    PathCombine(gP.szresource, EXEresource(), "gauge.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    nEnum = 10
    x = (%ClientWidth - ((bmH + xStep) * nEnum - xStep)) \ 2
    y = (%ClientHeight - (bmH * 2 + xStep)) \ 2
    CreateGauge(hBitmap, %ID_GAUGE_BACK, %ID_GAUGE_FRONT, %ID_GAUGE_LIGHT, x, y, nEnum, xStep)
    ZD_GetObjectXY(%ID_GAUGE_BACK, nLeftX, y)
    ZD_GetObjectXY(%ID_GAUGE_BACK + 9, nRightX, y)

    '// Create multiple switches
    PathCombine(gP.szresource, EXEresource(), "vSwitch.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    nEnum = 10
    x = (%ClientWidth - ((bmH + xStep) * nEnum - xStep)) \ 2
    y = (%ClientHeight - (bmH * 2 + xStep)) \ 2 + xStep + bmH
    CreateSwitch(hBitmap, %ID_GAUGE_SWITCH, x, y, nEnum, xStep)

    '// Create the tube cooler grid
    PathCombine(gP.szresource, EXEresource(), "grid.png")
    x = (%ClientWidth - ((bmH + xStep) * 10 - xStep)) \ 2
    y = 310
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_GRID
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
        ZD_SetObjectFrameCount(nID, 2)
        ZD_SetObjectFrameToUse(nID, 2, %FALSE) '// Start OFF
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if

    '// Create the power On/Off switch
    PathCombine(gP.szresource, EXEresource(), "hSwitch.png")
    x = nRightX: y = 370
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_POWER
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
        ZD_SetObjectFrameCount(nID, 2)
        ZD_SetObjectFrameToUse(nID, 2, %FALSE) '// Power OFF
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if

    '// Create the pulsating LED animation
    PathCombine(gP.szresource, EXEresource(), "pulse.png")
    x += 17: y = 366
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_PULSE
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_HIDDEN)
        ZD_SetObjectFrameCount(nID, bmW \ bmH)
        ZD_SetObjectFrameToUse(nID, 1, %FALSE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if
    '// Draw caption text using a private font
    PathCombine(gP.szresource, EXEresource(), "caption.ttf")
    nID = %ID_CAPTION
    ZD_DrawTextToCtrl(gP.imagectrl, _              '// The GDImage control handle
                      "tuning controls", _         '// The text to be displayed
                      nLeftX, _                    '// X coordinate
                      32, _                        '// Y coordinate
                      ZD_ARGB(255, 255,255,255), _ '// The ARGB color to use ZD_ARGB(255, 166,50,50)
                      gP.szresource, _             '// The True type Font to use
                      40, _                        '// The font size in pixel
                      nID, _                       '// The unique object ID
                      %ZS_VISIBLE, _               '// Show overlay
                      1, _                         '// Optional shadow effect (offset in pixel)
                      0)
    ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
    ZD_SetObjectLocked(nID, %TRUE)

    nID = %ID_LIST_FRAME
    w = 300: h = 102
    x = nRightX + 64 - w: y = 5
    '//ZD_DrawRectangleToCtrl(gP.imagectrl, x, y, w, h, ZD_ARGB(255, 32,8,1), 1, nID, %ZS_VISIBLE, %ZD_DRAW_FILLED, 0)
    ZD_DrawRectangleToCtrl(gP.imagectrl, x, y, w, h, ZD_ARGB(255, 2,17,32), 1, nID, %ZS_VISIBLE, %ZD_DRAW_FILLED, 0)
    ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
    ZD_SetObjectLocked(nID, %TRUE)
    '// Draw text list using a private font
    PathCombine(gP.szresource, EXEresource(), "font.ttf")
    nID = %ID_LIST_TEXT
    ZD_DrawTextToCtrlEx(gP.imagectrl, (sMsg(0)), x, y, -w, -h, ZD_ARGB(255, 255,255,255), _
                        gP.szresource, 16, nID, %ZS_VISIBLE, 0, %StringAlignmentNear)
    ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
    ZD_SetObjectLocked(nID, %TRUE)

    PathCombine(gP.szresource, EXEresource(), "glass.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_LIST_GLASS
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if

    '// Create vertical sliders
    x = nLeftX + (xWidth + xStep) * 2: y = 305: nEnum = 6
    PathCombine(gP.szresource, EXEresource(), "SlideV.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    PathCombine(gP.szresource, EXEresource(), "ThumbV.png")
    hThumb = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    CreateVerticalSlider(hBitmap, hThumb, x, y, xWidth, xStep, nEnum)

    '// Create tick control
    PathCombine(gP.szresource, EXEresource(), "tick3.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    nEnum = 1
    x = nRightX
    y = 300
    CreateGauge(hBitmap, %ID_TICK_BACK, %ID_TICK_FRONT, 0, x, y, nEnum, xStep)
    nID = %ID_TICK_TEXT
    PathCombine(gP.szresource, EXEresource(), "font.ttf")
    ZD_DrawTextToCtrlEx(gP.imagectrl, "0", x, y, bmH, bmH, &HFFFFFFFF, gP.szresource, 14, nID, _
                        %ZS_VISIBLE, -1000, %StringAlignmentCenter)
    ZD_SetObjectHidden(nID, 2) '// 2 = Transparent, its ID won't be detected and it couldn't be moved.

    '// We use a callback to monitor the GDImage control messages
    local lpCallBack as DWORD: lpCallBack = CODEPTR(GDImageCallBack)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_LBUTTONDOWN, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_LBUTTONUP, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_MOUSEMOVE, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_RBUTTONDOWN, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_RBUTTONDBLCLK, %TRUE)

end sub

sub RenderAnimation()
    if (IsPowerOn()) then
        local nFrame as long
        nFrame = ZD_GetObjectFrameToUse(%ID_PULSE) + 1: if nFrame > ZD_GetObjectFrameCount(%ID_PULSE) then nFrame = 1
        if ZD_IsObjectVisible(%ID_PULSE) = %FALSE then
            ZD_SetObjectFrameToUse(%ID_PULSE, 1, %FALSE)
            ZD_ShowObject(%ID_PULSE, %TRUE)
        else
            ZD_SetObjectFrameToUse(%ID_PULSE, nFrame, %TRUE)
        end if
    elseif ZD_IsObjectVisible(%ID_PULSE) then
        ZD_ShowObject(%ID_PULSE, %FALSE)
    end if
end sub

'// Main window minimum horizontal track size
function MinTrackSizeW (byval SizeX as long) as long
    static WasSizeX as long
    if (SizeX) then WasSizeX = SizeX
    function = WasSizeX
end function

'// Main window minimum vertical track size
function MinTrackSizeH (byval SizeY as long) as long
    static WasSizeY as long
    if (SizeY) then WasSizeY = SizeY
    function = WasSizeY
end function

function WndProc(byval hWnd as DWORD, byval uMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
    local ptNMHDR as NMHDR PTR
    local nID, nPercent, nTick as long
    static wasPercent, wasTick as long

    select case uMsg

    case %WM_GETMINMAXINFO 'Set minimum and naximum dialog size
         LOCAL MinMax as MINMAXINFO PTR
         MinMax = lParam
         @MinMax.ptMinTrackSize.x = MinTrackSizeW(0)
         @MinMax.ptMinTrackSize.y = MinTrackSizeH(0)
         function = 0: exit function

    case %WM_VSCROLL '// Slider/scrollbar vertical control
         if (LO(INTEGER, wParam) = %SB_THUMBPOSITION) then
             nID = lParam
             nPercent = HI(INTEGER, wParam)
zTrace("ID" + STR$(nID) + " VSCROLL =" + STR$(nPercent) + "%")
             function = 0: exit function
         end if

    case %WM_NOTIFY '// Gauge or Tick control
         ptNMHDR = lParam
         nID = wParam '// @ptNMHDR.idfrom
         if ((nID > %ID_GAUGE_BACK - 1) and (nID < %ID_GAUGE_LIGHT)) then
             nPercent = (((@ptNMHDR.code + 180) mod 360) / 360) * 100
             if (nPercent <> wasPercent) then
zTrace("ID" + STR$(nID) + ", angle =" + STR$(@ptNMHDR.code) + "," + STR$(nPercent) + "%")
             end if
         elseif ((nID > %ID_TICK_BACK) and (nID < %ID_TICK_FRONT + (%ID_TICK_FRONT - %ID_TICK_BACK))) then
             nTick = @ptNMHDR.code
             if (nTick <> wasTick) then
zTrace("ID" + STR$(nID) + ", tick =" + STR$(nTick))
                 PathCombine(gP.szresource, EXEresource(), "tick.wav")
                 PlaySound(gP.szresource, BYVAL %NULL, %SND_FILENAME or %SND_ASYNC)
                 ZD_SetObjectTextEx(%ID_TICK_TEXT, STR$(nTick), %TRUE)
             end if
             wasTick = nTick
         end if

    case %WM_TIMER
         RenderAnimation()

    case %WM_DESTROY
         PostQuitMessage(0)
         function = 0: exit function

    end select

    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

function WinMain (byval hInstance as DWORD, byval hPrevInstance as DWORD, _
                  byval lpCmdLine as ASCIIZ PTR, byval nCmdShow as long) as long

    LOCAL Msg         as tagMsg
    LOCAL wcx         as WndClassEx
    LOCAL szClass     as ASCIIZ * 16
    LOCAL hFound, hMutex, dwStyleEx, dwStyle as DWORD
    LOCAL x, y, IsInitialized as long

    szClass = "ZMCT32"

    hMutex = CreateMutex(byval %Null, 0, szClass)
    if (hMutex) then
        if (GetLastError = %ERROR_ALREADY_EXISTS) then
            do
               hFound = FindWindow(szClass, ""): if hFound then exit do
               while PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): wend
            loop
            if IsIconic(hFound) then ShowWindow(hFound, %SW_RESTORE)
            SetForeGroundWindow(hFound)
            function = 0: exit function
        end if
    end if

    gP.hInstance = hInstance
    wcx.cbSize = sizeof(WNDCLASSEX)
    IsInitialized = GetClassInfoEx(hInstance, szClass, wcx)
    if (IsInitialized     = 0) then
        wcx.style         = %CS_HREDRAW or %CS_VREDRAW
        wcx.lpfnWndProc   = CODEPTR(WndProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = hInstance
        wcx.hIcon         = %NULL
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %COLOR_WINDOW + 1
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = VARPTR(szClass)
        wcx.hIconSm       = wcx.hIcon
        if (RegisterClassEx(wcx)) then IsInitialized = -1
    end if

    if (IsInitialized) then
        local r as RECT
        dwStyleEx = 0
        dwStyle = %WS_POPUP or %WS_CAPTION or %WS_SYSMENU or %WS_MINIMIZEBOX or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN
        '// Adjust the window to use the client size.
        SetRect(r, 0, 0, %ClientWidth, %ClientHeight)
        AdjustWindowRectEx(r, dwStyle, %FALSE, dwStyleEx)
        MinTrackSizeW(r.nRight - r.nLeft)
        MinTrackSizeH(r.nBottom - r.nTop)
        x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - MinTrackSizeW(0)) \ 2, 0)
        y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - MinTrackSizeH(0)) \ 2, 0)

        '// The main window
        gP.hMain = CreateWindowExA(dwStyleEx, szClass, "MTC 32", _
                                   dwStyle, x, y, MinTrackSizeW(0), MinTrackSizeH(0), %NULL, %NULL, hInstance, byval %NULL)
        if (gP.hMain) then
            RegisterGDImageClass()

            '// Helper function to create A GDImage control.
            gP.imagectrl = ZI_CreateWindow(gP.hMain, 0, 0, %ClientWidth, %ClientHeight, %IDC_CTRL)
            '// Apply gradient to the background.
            ZI_SetProperty(gP.imagectrl, %ZI_GradientTop, RGB(64,64,64))
            ZI_SetProperty(gP.imagectrl, %ZI_GradientBottom, RGB(0,0,0))
            '// Anchor the conrol to full resize mode.
            ZI_SetAnchorMode(gP.imagectrl, %ANCHOR_HEIGHT_WIDTH)

            if (gP.imagectrl) then
                skSkinDisable(gP.imagectrl) '// Do not skin the main graphic control.
                PathCombine(gP.szresource, EXEpath(), "Ampli.sks")
                if skInitEngine(gP.szresource, "") then
                    skSkinWindow(gP.hMain, "Dock|Undock|Minimize|Maximize|Restore|Close")
                end if
            end if

            CreateControls()

            '// Show main window
            ShowWindow(gP.hMain, nCmdShow)
            SetForegroundWindow(gP.hMain)                  '// Slightly Higher Priority
            SetFocus(gP.imagectrl)                         '// Sets Keyboard Focus To The Window

            SetTimer(gP.hMain, %IDC_TIMER, 33, %NULL)
            while GetMessage(Msg, %NULL, 0, 0)
                  TranslateMessage(msg)                    '// Translate The Message
                  DispatchMessage(msg)                     '// Dispatch The Message
            wend
            KillTimer(gP.hMain, %IDC_TIMER)

            function = msg.wParam
         end if

    end if

    if (hMutex) then CloseHandle(hMutex)

end function
